#include <math.h>
#include "my_gfx.h"

char g_SinTable[256];

void Create_Sin_Table(void)
{
  int i;
  for(i=0; i<256; i++) g_SinTable[i] = (BYTE) (sin(i*PI/128)*25);
}

void Do_wave(BYTE *dst, int dx, int dy)
{
  int  x, y;
  int  i, j;
  BYTE *temp;

  temp = virtual_screen;
  for(y=0; y < 200; y++)
    for(x=0; x < 320; x++, temp++) {
      i = ( x + g_SinTable[ (x + dx) & 255] );
      j = ( y + g_SinTable[ (y + dy) & 255] );
      if( ( i > 0 ) && ( i < 320 ) && ( j >0 ) && ( j < 200 ) )
        *temp = *( dst + i + ( j << 8 ) + ( j << 6 ) );
    }
}
