/* Shuvax --> cRyOGeN's bORnTRo */
#include <stdio.h>
#include <time.h>
#include <conio.h>
#include <stdlib.h>
#include <strings.h>
#include "my_gfx.h"
#include "midasdll.h"
#include "demo.h"
#include "azpforg.h"

#define ILOSC_OBJ     17
#define ILOSC_SCIAN   3100
#define ILOSC_SWIATEL 1
#define ILOSC_TEX     11
#define ILOSC_PICT    10
#define NUMBER_OF_POINTS 116*41  // ilosc punktow do morphingu

/* Zmienne globalne */
volatile int TimerCount      = 0; // Ilosc wywolan timera
volatile int prevTimerCount  = 0; // Poprzednia wartosc timera
volatile int SynchroInfo     = 0; // Synchronizacja do muzyki ( komenda Wxx )
volatile int prevSynchroInfo = 0; // Poprzednia wartosc synchoInfo

MIDASmodulePlayHandle playHandle;
MIDASmodule           module;

int XLookup[320];                 // credits.c
int YLookup[200];                 // credits.c
BYTE katx = 0, katy = 0;          // credits.c
int SinTable[256];                // credits.c & bump.c
int CosTable[256];                // credits.c & bump.c
DWORD *tunnel_table1;             // tunnel.c
DWORD *tunnel_table2;             // tunnel.c
DWORD *tunnel_table;              // tunnel.c
punkt morph_table[NUMBER_OF_POINTS];

int wartosc = 0;

#define MAX_GREETS 22
void main(void)
{
  linia tablica[MAX_GREETS] = {
                        {234, 395, 379, 475,  55,  90},  // Greets go to:
                        { 16,   8, 199,  58,  50,  90},  // Amnesty
                        { 17,  68, 201, 103,  50,  90},  // Camorra
                        {213,  68, 319, 103,  80,  90},  // Echo
                        {331,  69, 490, 103,  60, 90},  // Enclave
                        { 16, 127, 160, 161,  70, 90},  // Enenzi
                        {171, 128, 361, 161,  45, 90},  // Exmortis
                        { 17, 185, 186, 233,  45, 90},  // Elysium
                        {196, 185, 365, 219,  55, 90},  // Fortress
                        {372, 127, 469, 162,  85, 90},  // Fuse
                        { 18, 301, 194, 336,  45, 90},  // Hellcore
                        {214, 243, 415, 289,  30, 90},  // Hypnotize
                        {205, 301, 358, 349,  55, 90},  // Liberty
                        {366, 304, 511, 351,  55, 90},  // Logrus
                        { 17, 359, 163, 394,  55, 90},  // Mosaic
                        {174, 359, 355, 395,  55, 90},  // Norferin
                        {334,  10, 476,  46,  65, 90},  // Poison
                        { 22, 238, 183, 272,  55, 90},  // Platoon
                        {376, 185, 486, 219,  75, 90},  // Pulse
                        {214,  10, 322,  45,  70, 90},  // Swirl
                        { 20, 434, 178, 510,  45, 90},  // Special Greets
                        { 13, 402, 229, 429,  35, 90}   // Mrock / Hellcore
                               };
  #define NUM_PATH 26
  campos  cam_path[NUM_PATH] = {
                         {  0,   5,  -10,   0,   0,   0, 150 },
                         {  0,   5,  20,   0,   0,   0, 100 },
                         {  0,   5,  31,   0,   0,   0, 50 },
                         {  0,   5,  37,   0,  0,   0, 150 },
                         {  0,   5,  61,   0, -51,   0, 50 },
                         {  0,   5,  65,   0, -60,   0, 100 },
                         {  0,   5,  68,   0, -115,   0, 50 },
                         {  0,   5,  70,   0, -124,   0, 70 },
                         {  0,   5,  79,   0, -141,   0, 70 },
                         {  0,   5,  80,   0, -128,   0, 50 },
                         {  0,   8,  64,   -10, -120,   0, 50 },
                         {  0,   8,  57,   -5, -120,   0, 50 },
                         {  0,   3,  47,   0, -88,   0, 70 },
                         {  10,   3,  47,   0, -108,   0, 50 },
                         {  15,   3,  40,   0, -118,   0, 30 },
                         {  10,   4,  53,   0, -108,   0, 150 },
                         {  10,   4,  53,   0, -178,   0, 250 },
                         {  -15,   5,  43,   0, -128,   0, 200 },
                         {  -5,   5,  13,   0, -18,   0, 150 },
                         {  2,   8,  37,   0, 0,   0, 50 },
                         {  2,   8,  37,   0, 0,   0, 150 },
                         {  2,   8,  37,   30, 0,   0, 100 },
                         {  2,   8,  37,   12, 0,   0, 100 },
                         {  2,   8,  37,   12, 0,   0, 150 },
                         {  2,   5,  77,   0, 0,   0, 1 },
                         {  2,   5,  77,   0, 0, 0, 1500 }
                        };
  RGB                   paleta_t[ILOSC_TEX][256];
  bitmap                tekstury[ILOSC_TEX];
  camera                kamera;
  DWORD                 dang1y, dang2x, dang2y;
  object3d              *temp_obj;
  point_3d              pozycja;

  BYTE                  blad;
  int                   skip_frames;
  bitmap                pict[ILOSC_PICT], phongmap;
  RGB                   pal1[256], pal2[256], pal3[256],
                        pal4[256], pal5[256], temp_pal[256];
  int                   i = 0;
  int                   posx, posy;
  BYTE                  *buf1;
  int                   test=0, test2=0;
  int                   ang_x, ang_y, ang_z;
  double                _dx, _dy, _dz;
  int                   _dax, _day, _daz;

   /* Inicjalizacja MIDASA */
  MIDASstartup();

  /* Konfiguracja karty dzwiekowej */
  if( !MIDASconfig() ) {
    if( ( i = MIDASgetLastError() ) ) {
      MIDASgetErrorMessage( i );
      printf("Config error.\n");
      MIDASclose();
      exit(0);
    }
    else {
      printf("Bye !\n");
      MIDASclose();
      exit(0);
    }
  }

  clrscr();
  printf("Shuvax --> cRyOGeN's bORnTRo\n");

  printf("  Loading textures..................."); fflush(stdout);
  if( (blad = Load_PCX("data.dat",&pict[0], pal5, 0, 43671) ) != NO_ERROR ) {
    Print_error(" error : ", blad);
    MIDASclose();
    exit(blad);
  }
  if( (blad = Load_PCX("data.dat",&pict[5], pal2, 43671, 20868) ) != NO_ERROR ) {
    Print_error(" error : ", blad);
    MIDASclose();
    exit(blad);
  }
  if( (blad = Load_PCX("data.dat",&pict[3], pal1, 64539, 45657) ) != NO_ERROR ) {
    Print_error(" error : ", blad);
    MIDASclose();
    exit(blad);
  }
  if( (blad = Load_PCX("data.dat",&pict[1], pal1, 110196, 2704 ) ) != NO_ERROR ) {
    Print_error(" error : ", blad);
    MIDASclose();
    exit(blad);
  }
  if( (blad = Load_PCX("data.dat",&tekstury[2], paleta_t[2], 112900, 15759) ) != NO_ERROR ) {
    Print_error(" error : ", blad);
    MIDASclose();
    exit(blad);
  }
  if( (blad = Load_PCX("data.dat",&pict[7], temp_pal, 128659, 29556) ) != NO_ERROR ) {
    Print_error(" error : ", blad);
    MIDASclose();
    exit(blad);
  }
  if( (blad = Load_PCX("data.dat",&pict[2], temp_pal, 158215, 2966) ) != NO_ERROR ) {
    Print_error(" error : ", blad);
    MIDASclose();
    exit(blad);
  }
  if( (blad = Load_PCX("data.dat",&tekstury[1], paleta_t[1], 161181, 55389) ) != NO_ERROR ) {
    Print_error(" error : ", blad);
    MIDASclose();
    exit(blad);
  }
  if( (blad = Load_PCX("data.dat",&tekstury[10], paleta_t[10], 216570, 26830) ) != NO_ERROR ) {
    Print_error("error : ", blad);
    MIDASclose();
    exit(blad);
  }
  if( (blad = Load_PCX("data.dat",&pict[8], temp_pal, 243400, 2148) ) != NO_ERROR ) {
    Print_error(" error : ", blad);
    MIDASclose();
    exit(blad);
  }
  if( (blad = Load_PCX("data.dat",&pict[4], pal2, 245548, 13700) ) != NO_ERROR ) {
    Print_error(" error : ", blad);
    MIDASclose();
    exit(blad);
  }
  if( (blad = Load_PCX("data.dat",&tekstury[9], paleta_t[9], 259248, 44959) ) != NO_ERROR ) {
    Print_error("error : ", blad);
    MIDASclose();
    exit(blad);
  }
  if( (blad = Load_PCX("data.dat",&tekstury[4], paleta_t[4],304207, 54380) ) != NO_ERROR ) {
    Print_error(" error : ", blad);
    MIDASclose();
    exit(blad);
  }
  if( (blad = Load_PCX("data.dat",&tekstury[5], paleta_t[5], 358587, 51147) ) != NO_ERROR ) {
    Print_error(" error : ", blad);
    MIDASclose();
    exit(blad);
  }
  if( (blad = Load_PCX("data.dat",&tekstury[6], paleta_t[6], 409734, 29623) ) != NO_ERROR ) {
    Print_error("error : ", blad);
    MIDASclose();
    exit(blad);
  }
  if( (blad = Load_PCX("data.dat",&pict[6], pal3, 439357, 8563) ) != NO_ERROR ) {
    Print_error(" error : ", blad);
    MIDASclose();
    exit(blad);
  }
  if( (blad = Load_BMP("data.dat",&tekstury[7], paleta_t[7], 447920) ) != NO_ERROR ) {
    Print_error("error : ", blad);
    MIDASclose();
    exit(blad);
  }
  if( (blad = Load_BMP("data.dat",&tekstury[0], paleta_t[0], 514534) ) != NO_ERROR ) {
    Print_error(" error : ", blad);
    MIDASclose();
    exit(blad);
  }
  if( (blad = Load_BMP("data.dat",&tekstury[3], paleta_t[3], 581148) ) != NO_ERROR ) {
    Print_error(" error : ", blad);
    MIDASclose();
    exit(blad);
  }
  if( (blad = Load_BMP("data.dat",&tekstury[8], paleta_t[8],647762) ) != NO_ERROR ) {
    Print_error("error : ", blad);
    MIDASclose();
    exit(blad);
  }
  if( (blad = Load_BMP("data.dat",&pict[9], pal4, 714376) ) != NO_ERROR ) {
    Print_error(" error : ", blad);
    MIDASclose();
    exit(blad);
  }
  else printf("ok.\n");

  printf("  Allocating memory ................."); fflush(stdout);
  if (( blad = Init_world(ILOSC_OBJ, ILOSC_SCIAN, ILOSC_SWIATEL) ) == ERR_NO_MEM ) {
    printf(" error : No enough memory");
    MIDASclose();
    exit(0);
  }
  if( ( buf1 = (BYTE *) malloc(65536) ) == NULL) {
    printf(" error : No enough memory. \n");
    MIDASclose();
    exit(0);
  }
  if( ( phongmap.data = (BYTE *) malloc(65536) ) == NULL) {
    printf(" error : No enough memory. \n");
    MIDASclose();
    exit(0);
  }
  if( ( tunnel_table1 = (DWORD *) malloc(64000 * sizeof(DWORD) ) ) == NULL) {
    printf(" error : No enough memory. \n");
    MIDASclose();
    exit(0);
  }
  if( ( tunnel_table2 = (DWORD *) malloc(64000 * sizeof(DWORD) ) ) == NULL) {
    printf(" error : No enough memory. \n");
    MIDASclose();
    exit(0);
  }

  // Wyczyszczenie buforow
  memset(buf1, 0, 64000);

  memset(temp_pal, 0, 768);

  printf("ok.\n");

  printf("  Loading 3D objects.................");  fflush(stdout);
  if ((blad = Load_mzl("data.dat", 2, 779454)) != NO_ERROR) {
    Print_error(" error : ", blad);
    Free_world();
    MIDASclose();
    exit(blad);
  }
  if ((blad = Load_mzl("data.dat", 1, 786662)) != NO_ERROR) {
    Print_error(" error : ", blad);
    Free_world();
    MIDASclose();
    exit(blad);
  }
  if ((blad = Load_mzl("data.dat", 8, 800830)) != NO_ERROR) {
    Print_error(" error : ", blad);
    Free_world();
    MIDASclose();
    exit(blad);
  }
  if ((blad = Load_mzl("data.dat", 11, 815550)) != NO_ERROR) {
    Print_error(" error : ", blad);
    Free_world();
    MIDASclose();
    exit(blad);
  }
  if ((blad = Load_mzl("data.dat", 13, 816686)) != NO_ERROR) {
    Print_error(" error : ", blad);
    Free_world();
    MIDASclose();
    exit(blad);
  }
  if ((blad = Load_mzl("data.dat", 16, 837814)) != NO_ERROR) {
    Print_error(" error : ", blad);
    Free_world();
    MIDASclose();
    exit(blad);
  }
  if ((blad = Load_mzl("data.dat", 3, 866004)) != NO_ERROR) {
    Print_error(" error : ", blad);
    Free_world();
    MIDASclose();
    exit(blad);
  }
  if ((blad = Load_mzl("data.dat", 7, 878588)) != NO_ERROR) {
    Print_error(" error : ", blad);
    Free_world();
    MIDASclose();
    exit(blad);
  }
  if ((blad = Load_mzl("data.dat", 15, 884716)) != NO_ERROR) {
    Print_error(" error : ", blad);
    Free_world();
    MIDASclose();
    exit(blad);
  }
  if ((blad = Load_mzl("data.dat", 12, 896640)) != NO_ERROR) {
    Print_error(" error : ", blad);
    Free_world();
    MIDASclose();
    exit(blad);
  }
  if ((blad = Load_mzl("data.dat", 6, 912392)) != NO_ERROR) {
    Print_error(" error : ", blad);
    Free_world();
    MIDASclose();
    exit(blad);
  }
  if ((blad = Load_mzl("data.dat", 10, 920248)) != NO_ERROR) {
    Print_error(" error : ", blad);
    Free_world();
    MIDASclose();
    exit(blad);
  }
  if ((blad = Load_mzl("data.dat", 5, 930336)) != NO_ERROR) {
    Print_error(" error : ", blad);
    Free_world();
    MIDASclose();
    exit(blad);
  }
  if ((blad = Load_mzl("data.dat", 14, 944456)) != NO_ERROR) {
    Print_error(" error : ", blad);
    Free_world();
    MIDASclose();
    exit(blad);
  }
  if ((blad = Load_mzl("data.dat", 0, 953680)) != NO_ERROR) {
    Print_error(" error : ", blad);
    Free_world();
    MIDASclose();
    exit(blad);
  }
  if ((blad = Load_mzl("data.dat", 4, 973656)) != NO_ERROR) {
    Print_error(" error : ", blad);
    Free_world();
    MIDASclose();
    exit(blad);
  }
  if ((blad = Load_mzl("data.dat", 9, 976592)) != NO_ERROR) {
    Print_error(" error : ", blad);
    Free_world();
    MIDASclose();
    exit(blad);
  }
  else printf("ok.\n");

  printf("  Initialize MIDAS Sound System......"); fflush(stdout);
  if( !MIDASinit() )
    MIDASerror();
  else printf("ok.\n");

  printf("  Loading module....................."); fflush(stdout);
  if ( (module = MIDASloadModule("shuvax.xm")) == NULL )
    MIDASerror();
  else printf("ok.\n");

  printf("  Some precalculations..............."); fflush(stdout);
  Create_lens_table();      // lens.c
  Create_Sin_Table();       // gel.c
  Calc_Lookup_Table();      // credits.c
  Calc_SinCos_Table();      // bump.c
  Calc_Phongmap(&phongmap); // bump.c
  Create_tunnel_table(TRUE, tunnel_table1);    // tunnel.c
  Create_tunnel_table(FALSE, tunnel_table2);    // tunnel.c
  CalculateMorphTable(&pict[8]);

  /* Przeskalowanie obiektow */
  Scale_object_to(0, 50);
  Scale_object_to(1, 20);
  Scale_object_to(2, 25);
  Scale_object_to(3, 23);
  Scale_object_to(4, 500);
  Scale_object_to(5, 20);
  Scale_object_to(6, 20);
  Scale_object_to(7, 20);
  Scale_object_to(8, 25);
  Scale_object_to(11, 20);
  Scale_object_to(12, 2);
  Scale_object_to(13, 25);
  Scale_object_to(14, 20);
  Scale_object_to(15, 25);
  Scale_object_to(16, 25);

  printf("ok.\n\n");

  /* Ustawienie timera */
  if( !MIDASsetTimerCallbacks(100000, FALSE, &TimerCallback, NULL, NULL) ) {
    printf("Setting timer "); MIDASerror();
  }

  /* Inicjacja biblioteki graficznej */
  FOCUS = 256;
  if( (blad=init_gfx(MODE_320x200x256, 0) ) != NO_ERROR ) {
    Print_error("Mode 13h initialization error : ", blad);
    MIDASclose();
    exit(blad);
  }

  /* Wlaczenie handlera klawiatury */
  Init_handler();

  /* Wlaczenie odtwarzania modulu */
  if( ( playHandle = MIDASplayModule(module, TRUE) ) == 0)
    MIDASerror();

  /* Wlaczenie automatycznego wywolywania funkcji synchronizujacej */
  if ( !MIDASsetMusicSyncCallback(playHandle, &SyncCallback) ) {
    printf("Setting synchro callback "); MIDASerror();
  }

  /* Poczatek dema */
  /* Ustawienie obiektow */
  pozycja.x = 50; pozycja.y = 2; pozycja.z = 50;
  Set_object_location(16, pozycja);
  Set_object_rotation(16, 64, 128, 0);
  Set_object_type    (16, ENVMAP_FACE);
  Set_object_shading (16, AMBIENT_SHADING, 0, 64);
  Set_object_texture (16, tekstury[10].data);
  Set_object_flags   (16, ~OBJ_ON, SET_MODE);

  pozycja.x = 0; pozycja.y = -50; pozycja.z = 50;
  Set_object_location(15, pozycja);
  Set_object_rotation(15, 128, 0, 192);
  Set_object_type    (15, ENVMAP_FACE);
  Set_object_shading (15, AMBIENT_SHADING, 0, 64);
  Set_object_texture (15, tekstury[9].data);
  Set_object_flags   (15, ~OBJ_ON | OBJ_TWOSIDED, SET_MODE);


  pozycja.x = 0; pozycja.y = 0; pozycja.z = 500;
  Set_object_location(14, pozycja);
  Set_object_rotation(14, 64, 0, 0);
  Set_object_type    (14, ENVMAP_FACE);
  Set_object_shading (14, AMBIENT_SHADING, 0, 64);
  Set_object_texture (14, tekstury[4].data);
  Set_object_flags   (14, ~OBJ_ON, SET_MODE);

  pozycja.x = 0; pozycja.y = 0; pozycja.z = 500;
  Set_object_location(13, pozycja);
  Set_object_rotation(13, 64, 0, 0);
  Set_object_type    (13, ENVMAP_FACE);
  Set_object_shading (13, AMBIENT_SHADING, 0, 64);
  Set_object_texture (13, tekstury[4].data);
  Set_object_flags   (13, ~OBJ_ON, SET_MODE);

  pozycja.x = 2; pozycja.y = 10; pozycja.z = 47;
  Set_object_location(12, pozycja);
  Set_object_rotation(12, 64, 128, 0);
  Set_object_type    (12, ENVMAP_FACE);
  Set_object_shading (12, AMBIENT_SHADING, 0, 64);
  Set_object_texture (12, tekstury[9].data);
  Set_object_flags   (12, ~OBJ_ON, SET_MODE);

  pozycja.x = 0; pozycja.y = 0; pozycja.z = 300;
  Set_object_location(11, pozycja);
  Set_object_rotation(11, 64, 0, 0);
  Set_object_flags   (11, ~OBJ_ON, SET_MODE);
  Set_object_type    (11, FLAT_FACE);
  Set_object_shading (11, AMBIENT_SHADING, 0, 64);

  pozycja.x = 0; pozycja.y = -5; pozycja.z = 56;
  Set_object_location(10, pozycja);
  Set_object_rotation(10, 64, 0, 0);
  Set_object_flags   (10, ~OBJ_ON, SET_MODE);
  Set_object_type    (10, TEXTURE_FACE);
  Set_object_shading (10, AMBIENT_SHADING, 0, 64);
  Set_object_texture (10, tekstury[7].data);

  pozycja.x = 0; pozycja.y = -5; pozycja.z = 56;
  Set_object_location(9, pozycja);
  Set_object_rotation(9, 64, 0, 0);
  Set_object_flags   (9, ~OBJ_ON, SET_MODE);
  Set_object_type    (9, TEXTURE_FACE);
  Set_object_shading (9, AMBIENT_SHADING, 0, 64);
  Set_object_texture (9, tekstury[8].data);

  pozycja.x = 0; pozycja.y = 10; pozycja.z = 56;
  Set_object_location(8, pozycja);
  Set_object_rotation(8, 64, 0, 0);
  Set_object_type    (8, ENVMAP_FACE);
  Set_object_shading (8, AMBIENT_SHADING, 0, 64);
  Set_object_texture (8, tekstury[6].data);
  Set_object_flags   (8, OBJ_ON, SET_MODE);

  pozycja.x = 0; pozycja.y = 0; pozycja.z = 56;
  Set_object_location(7, pozycja);
  Set_object_rotation(7, 0, 0, 0);
  Set_object_type    (7, ENVMAP_FACE);
  Set_object_shading (7, AMBIENT_SHADING, 0, 64);
  Set_object_texture (7, tekstury[5].data);
  Set_object_flags   (7, ~OBJ_ON, SET_MODE);

  pozycja.x = 0; pozycja.y = 0; pozycja.z = 56;
  Set_object_location(6, pozycja);
  Set_object_rotation(6, 64, 0, 0);
  Set_object_type   (6, ENVMAP_FACE);
  Set_object_shading(6, AMBIENT_SHADING, 0, 64);
  Set_object_texture(6, tekstury[4].data);
  Set_object_flags  (6, ~OBJ_ON, SET_MODE);

  pozycja.x = 0; pozycja.y = 0; pozycja.z = 56;
  Set_object_location(5, pozycja);
  Set_object_rotation(5, 0, 0, 0);
  Set_object_type   (5, ENVMAP_FACE);
  Set_object_shading(5, AMBIENT_SHADING, 0, 64);
  Set_object_texture(5, buf1);
  Set_object_flags  (5, ~OBJ_ON, SET_MODE);

  pozycja.x = 0; pozycja.y = 0; pozycja.z = 56;
  Set_object_location(4, pozycja);
  Set_object_rotation(4, 0, 0, 0);
  Set_object_type   (4, TEXTURE_FACE);
  Set_object_shading(4, AMBIENT_SHADING, 0, 64);
  Set_object_texture(4, tekstury[1].data);
  Set_object_flags  (4, ~OBJ_ON, SET_MODE);

  pozycja.x = 0; pozycja.y = 0; pozycja.z = 0;
  Set_object_location(3, pozycja);
  Set_object_rotation(3, 64, 0, 0);
  Set_object_type   (3, ENVMAP_FACE);
  Set_object_shading(3, AMBIENT_SHADING, 0, 64);
  Set_object_texture(3, tekstury[2].data);
  Set_object_flags  (3, ~OBJ_ON, SET_MODE);

  pozycja.x = 0; pozycja.y = 00; pozycja.z = 56;
  Set_object_location(2, pozycja);
  Set_object_rotation(2, 64, 0, 0);
  Set_object_type   (2, ENVMAP_FACE);
  Set_object_shading(2, AMBIENT_SHADING, 0, 64);
  Set_object_texture(2, tekstury[2].data);
  Set_object_flags  (2, ~OBJ_ON, SET_MODE);

  pozycja.x = 0; pozycja.y = 10; pozycja.z = 56;
  Set_object_location(1, pozycja);
  Set_object_rotation(1, 64, -35, 0);
  Set_object_type   (1, ENVMAP_FACE);
  Set_object_shading(1, AMBIENT_SHADING, 0, 64);
  Set_object_texture(1, tekstury[1].data);
  Set_object_flags  (1, ~OBJ_ON, SET_MODE);

  pozycja.x = 0; pozycja.y = -5; pozycja.z = 56;
  Set_object_location(0, pozycja);
  Set_object_rotation(0, 64, 0, 0);
  Set_object_flags   (0, ~OBJ_ON, SET_MODE);
  Set_object_type    (0, TEXTURE_FACE);
  Set_object_shading (0, AMBIENT_SHADING, 0, 64);
  Set_object_texture (0, tekstury[0].data);

  /* Ustawienie kamery */
  Initialize_camera(&kamera);

  /* Ustawienie swiatla */
  Set_light(0, -30, 0, 0, 0, 0, 50);

  /* Wyczyszczenie tablicy dla water */
  memset(Height, 0, 128000 * sizeof(int));

  SynchroInfo = prevSynchroInfo = 0;
  TimerCount  = prevTimerCount  = 0;

//  goto virt;

  /* Cryogen - 3D object & presents */
  memset(virtual_screen, 0, 64000);
  set_palette(paleta_t[6]);
  memcpy(temp_pal, paleta_t[6], 768);

  temp_obj = world + 8;

  pozycja.x = 0; pozycja.y = 10; pozycja.z = -6;
  Set_object_location(8, pozycja);

  test = -1;
  ang_x = temp_obj->angle_x << 8;
  ang_y = temp_obj->angle_y << 8;

  posx = posy = 0; // uzywane do fadein do bialego

  prevTimerCount = TimerCount;
  while( SynchroInfo < 5 ) {
    while( prevTimerCount == TimerCount );

    /* Obliczenie ile klatek pominac */
    skip_frames    = TimerCount - prevTimerCount;
    prevTimerCount = TimerCount;

    if( test >= 0) Draw_morph();
    Render_world(&kamera);
    wait_VBL();
    set_palette(temp_pal);
    swap_pages();
    memset(virtual_screen, 0, 64000);


    while(skip_frames) {
      if( SynchroInfo == 0 ) temp_obj->position.z += 0.435;
      if( SynchroInfo > 1 ) {
        ang_x += 192;
        ang_y += 192;
      }

      if( ( SynchroInfo > 2 ) && ( test < 127 ) ) {
        Do_morph();
        test ++;
      }

      // fadein do bialego - opoznienie 2
      if( (SynchroInfo > 3 ) && ( posy > 1 ) ) {
        for(i = 0; i < 256; i++) {
          if( temp_pal[i].r < 63 ) temp_pal[i].r++;
          if( temp_pal[i].g < 63 ) temp_pal[i].g++;
          if( temp_pal[i].b < 63 ) temp_pal[i].b++;
        }
        posy = 0;
      }
      else posy++;

      skip_frames--;
    }

    temp_obj->angle_x = ang_x >> 8;
    temp_obj->angle_y = ang_y >> 8;

    if(raw_key == 1) shutdown();
  }

  /* Shuvax */
  set_black_palette();
  memcpy(virtual_screen, pict[4].data, 64000);
  swap_pages();
//  fadein(pal2, 4);
  fade_from_white(pal2, 4);
  while( TimerCount < 1200 )
    if(raw_key == 1) shutdown();

  /* Credits */
  memset(virtual_screen, 0, 64000);
  swap_pages();
  set_palette(pal4);

  /* code : mOtzEl */
  i = 20; test = 0; test2 = -1;
  prevTimerCount = TimerCount;
  while( i < 512 ) {
    while( prevTimerCount == TimerCount );

    /* Obliczenie ile klatek pominac */
    skip_frames    = TimerCount - prevTimerCount;
    prevTimerCount = TimerCount;

    Do_surfer();
    Do_water(&pict[9]);
    if( i < 256 )Do_signzoom(&pict[1], i);
    if( test2 == 1 ) {
      Do_Sign(&pict[1], 96, 36);
      test2 = 0;
    }
    wait_VBL();
    swap_pages();

    while(skip_frames) {
      test += 64;
      i++;
      if( (test2 == -1) && (i >= 256) ) test2 = 1;
      skip_frames--;
    }
    w_katx = test >> 8;
    w_katy = test >> 8;
    if(raw_key == 1) shutdown();
  }

  /* music : ARTJOHN */
  i = 20; test2 = -1;
  prevTimerCount = TimerCount;
  while( i < 512 ) {
    while( prevTimerCount == TimerCount );

    /* Obliczenie ile klatek pominac */
    skip_frames    = TimerCount - prevTimerCount;
    prevTimerCount = TimerCount;

    Do_surfer();
    Do_water(&pict[9]);
    if( i < 256) Do_signzoom(&pict[2], i);
    if( test2 == 1 ) {
      Do_Sign(&pict[2], 96, 36);
      test2 = 0;
    }
    wait_VBL();
    swap_pages();

    while(skip_frames) {
      test += 64;
      i++;
      if( (test2 == -1) && (i >= 256) ) test2 = 1;
      skip_frames--;
    }
    w_katx = test >> 8;
    w_katy = test >> 8;
    if(raw_key == 1) shutdown();
  }

  /* Virtual reality 1 -> vreal.mzl & cross.mzl */
  memset(virtual_screen, 0, 64000);
  swap_pages();

  pozycja.x = 0; pozycja.y = 0; pozycja.z = 6;
  Set_object_location(11, pozycja);

  Set_object_flags   (8, ~OBJ_ON, SET_MODE);
  pozycja.x = 0; pozycja.y = 0; pozycja.z = 0;
  Set_camera_location(&kamera, pozycja);

  temp_obj = world;
  dang1y = temp_obj->angle_y << 8;
  temp_obj++;
  dang2x = temp_obj->angle_x << 8;
  dang2y = temp_obj->angle_y << 8;

  memset(virtual_screen, 0, 64000);
  memcpy(temp_pal, paleta_t[0], 768);
  set_palette(paleta_t[0]);

  Set_object_flags   (0, OBJ_ON, SET_MODE);
  Set_object_flags   (1, OBJ_ON, SET_MODE);
  test = test2 = 0; posx = 1;
  prevTimerCount = TimerCount;
  while( test < 65 ) {
    /* Rendering sceny */
    memcpy(virtual_screen, pict[5].data, 64000);
    Render_world(&kamera);
    if( posx == 1 ) {
      Set_object_flags   (0, ~OBJ_ON, SET_MODE);
      Set_object_flags   (1, ~OBJ_ON, SET_MODE);
      Set_object_flags   (11, OBJ_ON, SET_MODE);

      Render_world(&kamera);

      Set_object_flags   (0, OBJ_ON, SET_MODE);
      Set_object_flags   (1, OBJ_ON, SET_MODE);
      Set_object_flags   (11, ~OBJ_ON, SET_MODE);
    }
    wait_VBL();
    swap_pages();

    set_palette(temp_pal);

    while( prevTimerCount == TimerCount );

    /* Obliczenie ile klatek pominac */
    skip_frames    = TimerCount - prevTimerCount;
    prevTimerCount = TimerCount;

    while(skip_frames) {
      dang1y += 170; dang2y += 170;
      dang2x += 256;
      skip_frames--;

      // Ponizej jest fadeout z opoznieniem 10
      if( (TimerCount > 3350) && ( test2 > 4 ) ) {
        for(i = 0; i < 256; i++) {
          if( temp_pal[i].r > 0 ) temp_pal[i].r--;
          if( temp_pal[i].g > 0 ) temp_pal[i].g--;
          if( temp_pal[i].b > 0 ) temp_pal[i].b--;
        }
        test++; test2 = 0;
      }
      else test2++;

      if( (world + 11)->position.z < 300 ) {
        (world + 11)->position.z += 0.7;
        (world + 11)->angle_z --;
      }
      else {
        posx = 0;
        Set_object_flags   (11, ~OBJ_ON, SET_MODE);
      }
    }
    /* Zmiana katow obrotu obiektu */
    temp_obj = world;
    temp_obj->angle_y = (dang1y >> 8);

    temp_obj++;
    temp_obj->angle_x = (dang2x >> 8);
    temp_obj->angle_y = (dang2y >> 8);

    if(raw_key == 1) shutdown();
  }

  /* Rotozoomer & 3D */
  Set_object_flags  (0, ~OBJ_ON, SET_MODE);
  Set_object_flags  (1, ~OBJ_ON, SET_MODE);
  Set_object_flags  (2, OBJ_ON, SET_MODE);
  Set_object_flags   (11, ~OBJ_ON, SET_MODE);

  set_black_palette();
  memcpy(virtual_screen, pict[6].data, 64000);
  swap_pages();
  fadein(pal3, 4);

  while( SynchroInfo < 6 )
     if(raw_key == 1) shutdown();

  prevTimerCount = TimerCount;
  test  = 256; // wartosc skalujaca w fixed point 24.8
  test2 = 0;   // wartosc kata obrotu
  i     = 9;   // wartosc dodawana do test
  posx  = 2;   // wartosc dodawana do test2
  blad  = 1;   // uzywane przy zmianie obiektu z "crn" na "join us"

  temp_obj = world + 2;
  while( TimerCount < 6150 ) {

    while( prevTimerCount == TimerCount );

    /* Obliczenie ile klatek pominac */
    skip_frames = TimerCount - prevTimerCount;
    prevTimerCount   = TimerCount;

    Do_rotozoom(&pict[6], virtual_screen, test, test2);
    if( TimerCount < 4350 ) {
      wait_VBL();
      swap_pages();
    }
    else {
      Render_world(&kamera);
      wait_VBL();
      swap_pages();
    }

   while(skip_frames) {
      test += i;
      if( test > 512 ) i = -3;
      if( test < 128 ) i =  3;
      test2 += posx;

      temp_obj->angle_x ++;
      temp_obj->angle_y ++;
      temp_obj->angle_z ++;

      if( ( TimerCount > 5250 ) && (blad) ) {
        posx = -2;
        if( blad == 1 ) {
          temp_obj->position.z --;
          if( temp_obj->position.z < 0 ) blad++;
        }
        if( blad == 2 ) {
          temp_obj = world + 3;
          Set_object_flags  (2, ~OBJ_ON, SET_MODE);
          Set_object_flags  (3, OBJ_ON, SET_MODE);
          blad ++;
        }
        if( blad == 3 ) {
          temp_obj->position.z ++;
          if( temp_obj->position.z >= 56 ) blad=0;
        }
      }

      skip_frames--;
    }

    if(raw_key == 1) shutdown();
  }

  /* Gel */
  set_palette(pal3);
  ang_x = ang_y = 0; // przesuniecie do gela

  Set_object_flags  (3, ~OBJ_ON, SET_MODE);

  pozycja.x = 0; pozycja.y = 0; pozycja.z = 0;
  Set_camera_location(&kamera, pozycja);

  temp_obj = world + 11;

  prevTimerCount = TimerCount;
  while( temp_obj->position.z > 5 ) {

    while( prevTimerCount == TimerCount );

    /* Obliczenie ile klatek pominac */
    skip_frames = TimerCount - prevTimerCount;
    prevTimerCount   = TimerCount;

    if( TimerCount < 6950) {
      memset(virtual_screen, 0, 64000);
      Do_wave(pict[6].data, ang_x, ang_y);
    }
    else {
      Do_wave(pict[6].data, ang_x, ang_y);
      Render_world(&kamera);
    }
    wait_VBL();
    swap_pages();

    while(skip_frames) {
      temp_obj->angle_z --;
      if( TimerCount > 6950 ) {
        Set_object_flags  (11, OBJ_ON, SET_MODE);
        temp_obj->position.z--;
      }
      ang_y += 1;
      ang_x += 2;
      skip_frames--;
    }

    if(raw_key == 1) shutdown();
  }

  /* Tunel & 3D */
  set_palette(paleta_t[4]);
  test = test2 = 0;
  blad = 0; // ktory obiekt na ekranie
  posx = 0; i = 1; // bujanie sie choinki

  Set_object_flags   (8, ~OBJ_ON, SET_MODE);
  Set_object_flags  (11, ~OBJ_ON, SET_MODE);
  Set_object_flags  (3, ~OBJ_ON, SET_MODE);
  Set_object_flags  (4, ~OBJ_ON, SET_MODE);
  Set_object_flags  (5, ~OBJ_ON, SET_MODE);
  Set_object_flags  (6,  OBJ_ON, SET_MODE);

  pozycja.x = 0; pozycja.y = 0; pozycja.z = 0;
  Set_camera_location(&kamera, pozycja);

  pozycja.x = 0; pozycja.y = 0; pozycja.z = 500;
  Set_object_location(6, pozycja);

  tunnel_table = tunnel_table1;
  temp_obj = world + 6;

  prevTimerCount = TimerCount;
  while( TimerCount < 10235 ) {
    while( prevTimerCount == TimerCount );

    /* Obliczenie ile klatek pominac */
    skip_frames = TimerCount - prevTimerCount;
    prevTimerCount   = TimerCount;

    Do_tunnel(&tekstury[3], virtual_screen, test);
    Render_world(&kamera);
    wait_VBL();
    swap_pages();

    if( ( TimerCount > 8235) && ( blad == 0 ) ) blad = 1;
    if( ( temp_obj->position.z <= -15 ) && ( blad == 1 ) ) {
      Set_object_flags(6, ~OBJ_ON, SET_MODE);
      temp_obj = world + 13;
      Set_object_flags   (13, OBJ_ON, SET_MODE);
      blad = 2;
    }
    if( ( TimerCount > 9535) && ( blad == 2 ) ) blad = 3;
    if( ( temp_obj->position.z <= -15 ) && ( blad == 3 ) ) {
      Set_object_flags(13, ~OBJ_ON, SET_MODE);
      temp_obj = world + 14;
      Set_object_flags (14, OBJ_ON, SET_MODE);
      pozycja.x = 0; pozycja.y = 0; pozycja.z = 500;
      Set_object_location(14, pozycja);
      blad = 4;
    }
    if( ( TimerCount > 10235) && ( blad == 4 ) ) blad = 5;
    if( (temp_obj->position.z <= -15) && ( blad == 5) ) {
      Set_object_flags(14, ~OBJ_ON, SET_MODE);
      blad = 6;
    }

    while(skip_frames) {
      test2 += 65536 + 256;

      switch( blad ) {
        case 0 : if( temp_obj->position.z > 46 ) temp_obj->position.z --;
                 temp_obj->angle_x ++;
                 temp_obj->angle_y --;
                 temp_obj->angle_z --;
                 break;
        case 1 : if( temp_obj->position.z > -15 ) temp_obj->position.z --;
                 temp_obj->angle_x ++;
                 temp_obj->angle_y --;
                 temp_obj->angle_z --;
                 break;
        case 2:  if( temp_obj->position.z > 46 ) temp_obj->position.z --;
                 temp_obj->angle_x ++;
                 temp_obj->angle_z --;
                 break;
        case 3 : if( temp_obj->position.z > -15 ) temp_obj->position.z --;
                 temp_obj->angle_x ++;
                 temp_obj->angle_z --;
                 break;
        case 4 : if( temp_obj->position.z > 46 ) temp_obj->position.z --;
                 temp_obj->angle_y --;
           /*      posx += i;
                 if(posx > 26) i = -1;
                 if(posx < -26) i = 1;
                 temp_obj->angle_z = (BYTE) posx;
            */  temp_obj->angle_z ++;
                 break;
        case 5 : if( temp_obj->position.z > -15 ) temp_obj->position.z --;
                 temp_obj->angle_y --;
                 break;
      }

      skip_frames--;
    }

    test = test2 >> 8;
    if(raw_key == 1) shutdown();
  }
  Set_object_flags(14, ~OBJ_ON, SET_MODE);

  /* Mieszadlo */
  memset(virtual_screen, 0, 64000);
  swap_pages();

  test = test2 = i = 0;
  set_palette(paleta_t[5]);

  Set_object_flags  (6, ~OBJ_ON, SET_MODE);
  Set_object_flags  (7, OBJ_ON, SET_MODE);

  pozycja.x = 0; pozycja.y = 0; pozycja.z = 0;
  Set_camera_location(&kamera, pozycja);

  pozycja.x = 0; pozycja.y = 0; pozycja.z = -100;
  Set_object_location(7, pozycja);

  tunnel_table = tunnel_table2;
  temp_obj = world + 7;

  while( TimerCount < 11335 ) {
    while( prevTimerCount == TimerCount );

    /* Obliczenie ile klatek pominac */
    skip_frames = TimerCount - prevTimerCount;
    prevTimerCount   = TimerCount;

    Do_tunnel(&tekstury[5], virtual_screen, test);
    Render_world(&kamera);
    wait_VBL();
    swap_pages();

    while(skip_frames) {
      if( ( temp_obj->angle_x == 64 ) && (test2 == 0) ) i = 1;
      if( test2 > 32896000 ) i = 2;

      if( temp_obj->position.z < 60 ) {
        temp_obj->position.z ++;
      }
      else if( temp_obj->angle_x < 64) {
        temp_obj->angle_x ++;
      }

      if( i == 1 ) {
        temp_obj->angle_z --;
        test2 += 65536 + 256;
      }
      else if( i == 2 ){
        temp_obj->angle_z ++;
        test2 -= 65536 + 256;
      }

      skip_frames--;
    }

    test = test2 >> 8;
    if(raw_key == 1) shutdown();
  }

  /* Virtual reality 2 - kanapy, stolek */
  test  = 0; // aktualna pozycja na sciezce
  test2 = 0; // krok w aktualnej pozycji
  Set_object_flags   (7, ~OBJ_ON, SET_MODE);
  Set_object_flags   (8, ~OBJ_ON, SET_MODE);

  pozycja.x = cam_path[test].x;
  pozycja.y = cam_path[test].y;
  pozycja.z = cam_path[test].z;
  Set_camera_location(&kamera, pozycja);
  ang_x = ang_y = ang_z = 0;
  Set_camera_rotation(&kamera, ang_x, ang_y, ang_x);

  _dx = ( cam_path[test+1].x - cam_path[test].x ) / cam_path[test].steps;
  _dy = ( cam_path[test+1].y - cam_path[test].y ) / cam_path[test].steps;
  _dz = ( cam_path[test+1].z - cam_path[test].z ) / cam_path[test].steps;

  _dax = ( ( cam_path[test+1].ax - cam_path[test].ax ) << 16 ) / cam_path[test].steps;
  _day = ( ( cam_path[test+1].ay - cam_path[test].ay ) << 16 ) / cam_path[test].steps;
  _daz = ( ( cam_path[test+1].az - cam_path[test].az ) << 16 ) / cam_path[test].steps;

  memset(virtual_screen, 0, 64000);
  swap_pages();
  set_palette(paleta_t[7]);

  Set_object_flags   (9, OBJ_ON, SET_MODE);
  Set_object_flags   (10, OBJ_ON, SET_MODE);

  temp_obj = world + 12;
  prevTimerCount = TimerCount;
  while( test < 23 ) {
     while( prevTimerCount == TimerCount );

    /* Obliczenie ile klatek pominac */
    skip_frames    = TimerCount - prevTimerCount;
    prevTimerCount = TimerCount;

    /* Rendering sceny */
    memcpy(virtual_screen, pict[0].data, 64000);
    Render_world(&kamera);
    wait_VBL();
    swap_pages();

    while(skip_frames) {
      test2++;

      if( test2 >= cam_path[test].steps ) {
        test2 = 0;
        test++;
        //if( test >= (NUM_PATH - 1) ) test = 0;

        pozycja.x = cam_path[test].x;
        pozycja.y = cam_path[test].y;
        pozycja.z = cam_path[test].z;

        ang_x = cam_path[test].ax << 16;
        ang_y = cam_path[test].ay << 16;
        ang_z = cam_path[test].az << 16;

        _dx = ( cam_path[test+1].x - cam_path[test].x ) / cam_path[test].steps;
        _dy = ( cam_path[test+1].y - cam_path[test].y ) / cam_path[test].steps;
        _dz = ( cam_path[test+1].z - cam_path[test].z ) / cam_path[test].steps;

        _dax = ( ( cam_path[test+1].ax - cam_path[test].ax ) << 16 ) / cam_path[test].steps;
        _day = ( ( cam_path[test+1].ay - cam_path[test].ay ) << 16 ) / cam_path[test].steps;
        _daz = ( ( cam_path[test+1].az - cam_path[test].az ) << 16 ) / cam_path[test].steps;
      }
      else {
        pozycja.x += _dx; pozycja.y += _dy; pozycja.z += _dz;
        ang_x += _dax;
        ang_y += _day;
        ang_z += _daz;
      }

      skip_frames--;
    }
    Set_camera_location(&kamera, pozycja);
    Set_camera_rotation(&kamera, (BYTE) ( ang_x >> 16 ),
                                 (BYTE) ( ang_y >> 16 ),
                                 (BYTE) ( ang_z >> 16 ) );
    if(raw_key == 1) shutdown();
  }


  Set_object_flags (12, OBJ_ON, SET_MODE);

  pozycja.x = 2;
  pozycja.y = 8;
  pozycja.z = 37;
  Set_camera_location(&kamera, pozycja);
  Set_camera_rotation(&kamera, 12, 0, 0);

  test = 0;

  prevTimerCount = TimerCount;
  while( kamera.position.z < 117 ) {
     while( prevTimerCount == TimerCount );

    /* Obliczenie ile klatek pominac */
    skip_frames    = TimerCount - prevTimerCount;
    prevTimerCount = TimerCount;

    /* Rendering sceny */
    memcpy(virtual_screen, pict[0].data, 64000);
    Render_world(&kamera);
    wait_VBL();
    swap_pages();

    while(skip_frames) {
      if( (temp_obj->position.y > 3.1 ) && ( test == 0 ) ) {
        temp_obj->position.y -= 0.025;
      }
      else test = 1;
      if( test ) {
        kamera.position.z += 0.27;
        kamera.position.y -= 0.02;
      }

      if(kamera. position.z > 40 ) {
        temp_obj->position.z +=0.27;
        temp_obj->position.y -= 0.01;
      }

      skip_frames--;
    }

    if(raw_key == 1) shutdown();
  }
  Set_object_flags   (9, ~OBJ_ON, SET_MODE);
  Set_object_flags   (10, ~OBJ_ON, SET_MODE);

  /* Romulan */
  test = 0;
  prevTimerCount = TimerCount;
  while( temp_obj->position.z > 119 ) {
     while( prevTimerCount == TimerCount );

    /* Obliczenie ile klatek pominac */
    skip_frames    = TimerCount - prevTimerCount;
    prevTimerCount = TimerCount;

    /* Rendering sceny */
    memcpy(virtual_screen, pict[0].data, 64000);
    Render_world(&kamera);
    wait_VBL();
    swap_pages();

    while(skip_frames) {
      if( test < 640 ) temp_obj->angle_y --;
      else temp_obj->position.z -= 0.04;
      test ++;

      skip_frames--;
    }

    if(raw_key == 1) shutdown();
  }
  Set_object_flags   (12, ~OBJ_ON, SET_MODE);

  /* Maska */
  pozycja.x = pozycja.y = pozycja.z = 0;
  Set_camera_location(&kamera, pozycja);
  Set_camera_rotation(&kamera, 0, 0, 0);

  Set_object_flags   (15, OBJ_ON | OBJ_TWOSIDED, SET_MODE);
  temp_obj = world + 15;

  posx = temp_obj->angle_x << 8;
  posy = temp_obj->angle_z << 8;

  prevTimerCount = TimerCount;
  while( SynchroInfo < 0x30 ) {
     while( prevTimerCount == TimerCount );

    /* Obliczenie ile klatek pominac */
    skip_frames    = TimerCount - prevTimerCount;
    prevTimerCount = TimerCount;

    /* Rendering sceny */
    memcpy(virtual_screen, pict[0].data, 64000);
    Render_world(&kamera);
    wait_VBL();
    swap_pages();

    while(skip_frames) {
      if( temp_obj->position.y < 0 ) temp_obj->position.y += 0.25;
      else {
        posx += 128;
        posy += 128;
        temp_obj->angle_y ++;
      }
//      if( TimerCount > 16485 ) temp_obj->position.y += 0.35;
      if( SynchroInfo > 0x1f ) temp_obj->position.y += 0.35;
      skip_frames--;
    }
    temp_obj->angle_x = posx >> 8;
    temp_obj->angle_z = posy >> 8;

    if(raw_key == 1) shutdown();
  }
  Set_object_flags   (15, ~OBJ_ON, SET_MODE);

  /* Greetings */
  for(i=0; i<256; i++) set_dac_color(i, 63, 63, 63);

  memset(virtual_screen, 0, 64000);
  swap_pages();
  set_palette(paleta_t[0]);

  Set_object_flags  (8, ~OBJ_ON, SET_MODE);

  Set_object_flags  (11, ~OBJ_ON, SET_MODE);
  Set_object_flags  (3, ~OBJ_ON, SET_MODE);
  Set_object_flags  (4, OBJ_ON, SET_MODE);
  Set_object_flags  (5, OBJ_ON, SET_MODE);
  Set_object_texture(5, buf1);

  pozycja.x = 0; pozycja.y = 0; pozycja.z = 450;
  Set_object_location(4, pozycja);

  pozycja.x = 0; pozycja.y = 0; pozycja.z = 60;
  Set_object_location(5, pozycja);

  temp_obj = world + 5;
  dang2x = temp_obj->angle_x << 8;
  dang2y = temp_obj->angle_y << 8;
  temp_obj--;
  test = test2 = i = 0;

  prevTimerCount = TimerCount;
  while( kamera.position.z < 200 ) {
    // Uaktualnienie envmapy
    if( test < 22 ) {
      memcpy(buf1, tekstury[1].data, 65536);
      update_envmap(&pict[7], buf1, tablica[test].s_x, tablica[test].s_y,
                    tablica[test].s2_x, tablica[test].s2_y,
                    tablica[test].d_x, tablica[test].d_y, 191);
    }

    while( prevTimerCount == TimerCount );

    /* Obliczenie ile klatek pominac */
    skip_frames = TimerCount - prevTimerCount;
    prevTimerCount   = TimerCount;

    Render_world(&kamera);
    wait_VBL();
    swap_pages();

    while(skip_frames) {
      temp_obj->angle_x ++;
      temp_obj->angle_y --;
      dang2x += 128;
      dang2y -= 128;

      if( test > 21 ) kamera.position.z ++;

      test2++;

      skip_frames--;
    }

    if( test2 > 400) {
      test2 -= 400;
      test++;
    }

    if( test > 21 ) test = 22;

    temp_obj++;
    temp_obj->angle_x = (dang2x >> 8);
    temp_obj->angle_z = (dang2y >> 8);
    temp_obj--;

    if(raw_key == 1) shutdown();
  }

  /* Head */
virt:
  memset(virtual_screen, 0 ,64000);
  swap_pages();
  set_palette(paleta_t[10]);

  Set_object_flags  (8, ~OBJ_ON, SET_MODE);
  Set_object_flags  (4, ~OBJ_ON, SET_MODE);
  Set_object_flags  (5, ~OBJ_ON, SET_MODE);
  Set_object_flags  (16, OBJ_ON, SET_MODE);

  pozycja.x = pozycja.y = pozycja.z = 0;
  Set_camera_location(&kamera, pozycja);

  temp_obj = world + 16;
  posx = temp_obj->angle_y << 8;

  test = test2 = 0;
  prevTimerCount = TimerCount;
  while( temp_obj->position.x > -40 ) {
    while( prevTimerCount == TimerCount );

    /* Obliczenie ile klatek pominac */
    skip_frames = TimerCount - prevTimerCount;
    prevTimerCount   = TimerCount;

    memset(virtual_screen, 0, 64000);
    Render_world(&kamera);
    wait_VBL();
    swap_pages();

    while(skip_frames) {
      if( temp_obj->position.x > 0) {
        temp_obj->position.x -= 0.1;
        posx += 128;
      }
      else posx += 128;

      if( SynchroInfo > 0x5f ) {
        temp_obj->position.x -= 0.1;
      }

      skip_frames--;
    }

    temp_obj->angle_y = posx >> 8;
    if(raw_key == 1) shutdown();
  }

  /* Bumpmap */
  memset(virtual_screen, 0, 64000);
  swap_pages();
  /* Ustawienie palety kolorow */
  /* Od czarnego do fioletowego */
  for (i = 0; i < 192; i++)
  {
   set_dac_color(i, (i*63) / 192, 0, (i*63) / 192);
  }
  /* Od fioletowego do bialego */
  for (i = 192; i < 256; i++)
  {
   set_dac_color(i, 63, i - 192, 63);
  }

  katx = katy = 0;
  posx = ( CosTable[katx += 2] >> 1 ) + 160;
  posy = ( SinTable[katy += 2] >> 2 ) + 100;
  test2 = 64 << 8; // glosnosc muzyki
  test = prevTimerCount = TimerCount;
  while( TimerCount < ( test + 1024 ) ) {

    while( prevTimerCount == TimerCount );

    /* Obliczenie ile klatek pominac */
    skip_frames    = TimerCount - prevTimerCount;
    prevTimerCount = TimerCount;

    Do_bump(&pict[3], &phongmap, posx, posy);
    wait_VBL();
    swap_pages();

    while(skip_frames) {
      katx++; katy++;
      if( ( SynchroInfo > 0x6f ) && ( test2 > 0 ) )test2 -= 16;
      skip_frames--;
    }
    posx = ( CosTable[katx] >> 1 ) + 160;
    posy = ( SinTable[katy] >> 2 ) + 100;

    MIDASsetMusicVolume(playHandle, test2 >> 8);

    if(raw_key == 1) shutdown();
  }

//  goto aaa;

  free(buf1); //free(buf2); free(buf3);
  free(phongmap.data);
 // for(i = 0; i < ILOSC_PICT; i++)
 //   free(pict[i].data);

  /* Shutdown */
  shutdown();
}

void MIDAS_CALL TimerCallback(void)
{
  TimerCount++;
}

void MIDAS_CALL SyncCallback(unsigned syncNum, unsigned position, unsigned row)
{
  SynchroInfo = syncNum;
}

void MIDASerror(void)
{
  printf("error: %s\n", MIDASgetErrorMessage(MIDASgetLastError()));
  MIDASclose();
  exit(255);
}

void fadein(RGB *pal, BYTE speed)
{
  RGB temp_pal[256];
  int i, j;
  int wszystkie;
  int temp;

  memset(temp_pal, 0, 768);
  for(j = 0; j < 64; j++) {
    wszystkie = 0;
    for(i = 0; i < 256; i++) {
      if( temp_pal[i].r < pal[i].r ) temp_pal[i].r++;
      else wszystkie++;
      if( temp_pal[i].g < pal[i].g ) temp_pal[i].g++;
      else wszystkie++;
      if( temp_pal[i].b < pal[i].b ) temp_pal[i].b++;
      else wszystkie++;
      set_dac_colorRGB(i, temp_pal[i]);
    }
    if( wszystkie == 768 ) j = 64;
    temp = TimerCount;
    while( TimerCount < (temp + speed) )
      if(raw_key == 1) shutdown();
  }
}

void fadeout(RGB *pal, BYTE speed)
{
  RGB temp_pal[256];
  int i, j;
  int wszystkie;
  int temp;

  memcpy(temp_pal, pal, 768);
  for(j = 0; j < 64; j++) {
    wszystkie = 0;
    for(i = 0; i < 256; i++) {
      if( temp_pal[i].r ) temp_pal[i].r--;
      else wszystkie++;
      if( temp_pal[i].g ) temp_pal[i].g--;
      else wszystkie++;
      if( temp_pal[i].b ) temp_pal[i].b--;
      else wszystkie++;
      set_dac_colorRGB(i, temp_pal[i]);
    }
    if( wszystkie == 768 ) j = 64;
    temp = TimerCount;
    while( TimerCount < (temp + speed) )
      if(raw_key == 1) shutdown();
  }
}

void fade_from_white(RGB *pal, BYTE speed)
{
  RGB temp_pal[256];
  int i, j;
  int wszystkie;
  int temp;

  memset(temp_pal, 63, 768);
  for(j = 0; j < 64; j++) {
    wszystkie = 0;
    for(i = 0; i < 256; i++) {
      if( temp_pal[i].r > pal[i].r ) temp_pal[i].r--;
      else wszystkie++;
      if( temp_pal[i].g > pal[i].g ) temp_pal[i].g--;
      else wszystkie++;
      if( temp_pal[i].b > pal[i].b ) temp_pal[i].b--;
      else wszystkie++;
      set_dac_colorRGB(i, temp_pal[i]);
    }
    if( wszystkie == 768 ) j = 64;
    temp = TimerCount;
    while( TimerCount < (temp + speed) )
      if(raw_key == 1) shutdown();
  }
}

void copy_selection(bitmap *src, int b_x, int b_y, int width, int height,
                    int x, int y)
{
  int  i;
  BYTE *temp, *temp2;

  temp = src->data + b_x + ( b_y * src->width );
  temp2 = virtual_screen + x + (y << 8) + (y << 6);
  for(i = height; i > 0; i--, temp2 += 320, temp += src->width)
    memcpy(temp2, temp, width);
}

void update_envmap(bitmap *src, BYTE *dst, int b_x, int b_y,
                   int b2_x, int b2_y, int x, int y, BYTE col)
{
  int  i, j;
  BYTE *temp, *temp2;
  int  width, height;

  width = b2_x - b_x + 1;
  height = b2_y - b_y + 1;

  temp = src->data + b_x + ( b_y << 9 );
  temp2 = dst + x + (y << 8);
  for(i = height; i > 0; i--, temp2 += (256 - width), temp += (512 - width) )
    for(j = width; j >0; j--, temp2++, temp++)
     if(*temp) *temp2 = col;
}

    /* Zmiana wartosci synchronizacji do muzyki */
/*    if( SynchroInfo != prevSynchroInfo ) {
      prevSynchroInfo = SynchroInfo;
    }
*/

void shutdown(void)
{
  deinit_gfx();

  /* Zakonczenie odgrywania modulu */
  if( !MIDASstopModule(playHandle) )
    MIDASerror();

  /* Zwolnienie pamieci zajmowanej przez modul */
  if( !MIDASfreeModule(module) )
    MIDASerror();

  /* Zakonczenie timera */
  if( !MIDASremoveTimerCallbacks() )
    MIDASerror();

  /* Deinicjalizacja MIDASA */
  MIDASclose();

  Remove_handler();

  printf("eXiT tO heLL........\n\n");

  printf("Credits :\n");
  printf("  Code         : mOtzEl\n");
  printf("  Music        : ARTJOHN\n");
  printf("  Sound System : MIDAS by Sahara Surfers\n\n");

//  printf("Wartosc  = %d\n", wartosc);
//  printf("Wartosc2 = %d\n", wartosc2);

  exit(0);
}

void CalculateMorphTable(bitmap *src)
{
  int  x, y, offs, offs2;
  int  tempx, tempy;
  BYTE *temp;

  temp = src->data;
  offs = offs2 = 0;
  for(y = 0; y < src->height; y++)
    for(x = 0; x < src->width; x++, temp++, offs++) {
      tempx = (rand() % 320) << 8;
      tempy = (rand() % 200)  << 8;
//      tempx = ( (offs2 % 320) << 8);
//      if( offs > 2378) tempy = ( (offs2 / 320) << 8) + 38400;
//      else tempy = ( (offs2 / 320) << 8) + 46080;
      morph_table[offs].posx  = tempx;
      morph_table[offs].dx    = ( ( (102 + x) << 8 ) - tempx ) >> 7;
      morph_table[offs].posy  = tempy;
      morph_table[offs].dy    = ( ( (150 + y) << 8 ) - tempy ) >> 7;
      morph_table[offs].color = *temp;
      if( *temp ) {
        morph_table[offs].active = 1;
        offs2++;
      }
      else morph_table[offs].active = 0;
    }
}

void Do_morph(void)
{
  int i;

  for(i=0; i < NUMBER_OF_POINTS; i++)
    if( morph_table[i].active ) {
      morph_table[i].posx += morph_table[i].dx;
      morph_table[i].posy += morph_table[i].dy;
    }
}

void Draw_morph(void)
{
  int i, tempy;

  for(i=0; i < NUMBER_OF_POINTS; i++)
    if( morph_table[i].active ) {
      tempy = morph_table[i].posy >> 8;
      *( virtual_screen +
         ( morph_table[i].posx >> 8 ) +
         ( ( tempy << 8 ) + ( tempy << 6 ) ) ) = 255;
    }
}
