#include <stdlib.h>
#include <math.h>
#include "my_gfx.h"

extern int XLookup[320];                 // credits.c
extern int YLookup[200];                 // credits.c
extern BYTE katx, katy;                  // credits.c

void Blur_buffer(BYTE *buf1, BYTE *buf2)
{
  int x, y;
  int srednia;
  BYTE *temp, *temp2;

  temp  = buf1 + 320; // 30*320 = 9600
  temp2 = buf2 + 320;
  for(y = 1; y < 199; y++)
    for(x = 0; x < 320; x++, temp++, temp2++) {
      srednia = ( *(temp + 1)  + *(temp - 1) +
                  *(temp +320) + *(temp - 320) ) >> 2;
      if(srednia) srednia--;
      *temp2 = srednia;
    }
}

void Scale_buffer(BYTE *buf1, BYTE *buf2)
{
  int x, y;
  BYTE *temp, *temp2;

  temp  = buf1 + 320; // 30*320 = 9600
  temp2 = buf2 + 320;
  for(y = 1; y < 199; y++)
    for(x = 0; x < 320; x++, temp2++) {
      *temp2 = *( temp + YLookup[y] + XLookup[x] );
    }

}

void Calc_Lookup_Table(void)
{
  int i, j;

  j = 320 - ( 10 << 1);
  for(i = 0; i < 320; i++)
    XLookup[i] = (int) ( ( (float) i / 320 ) * j + 10 );

  j = 200 - ( 10 << 1);
  for(i = 0; i < 200; i++) {
    YLookup[i] = (int) ( ( (float) i / 200 ) * j + 10) * 320;
  }
}

void Do_garbage(BYTE *where)
{
  int i, j, k;
  int x, y;

  // Wyswietlanie jasnych kropek
  for(i=0; i < 15; i++) {
    x = rand() % 310; y = rand() % 130 + 30;
    for(j=0; j < 5; j++)
      for(k=0; k < 5; k++)
        *(where + j + x + ((k+y) << 8) + ((k+y) << 6) ) = 58;
  }

  // Wyswietlanie ciemnych kropek
  for(i=0; i < 8; i++) {
    x = rand() % 320; y = rand() % 200;
    for(j=0; j < 5; j++)
      for(k=0; k < 5; k++)
        *(where + j + x + ((k+y) << 8) + ((k+y) << 6) ) = 0;
  }

}

/* pobiera z bitmapy src wycinek i wpisuje go do dst */
void get_line(bitmap src, BYTE *dst, int x, int y, int width, int height)
{
  BYTE *temp, *temp2;
  int  i;

  temp  = src.data + x + (y << 9) + (y << 7); // bitmapa ma 640 szerokosci
  temp2 = dst;
  for(i = height; i > 0; i--, temp += src.width, temp2 += width )
    memcpy(temp2, temp, width);
}

/* przepisuje wycinek src do bufora dst */
void put_line(BYTE *src, BYTE *dst, int x, int y, int width, int height,
              BYTE color)
{
  BYTE *temp, *temp2;
  int  i, j;

  temp  = dst + x + (y << 8) + (y << 6);
  temp2 = src;
  for(i = height; i > 0; i--, temp += (320 - width) )
    for(j = width; j > 0; j--, temp++, temp2++)
      if(*temp2) *temp = color;

}
